//Hfd. 20 OEF 2

public class ControleHaakjes
{
   private static StackComposition stack;

   // controleert de haakjes van een expressie
   public static boolean controle( String expressie )
   {
        char kar, openingshaakje;
        boolean geldig;
        stack = new StackComposition();
        for (int i=0; i<expressie.length(); i++)
        {
			kar = expressie.charAt(i);
			switch (kar)
			{
				case ']': 	openingshaakje = '[';
							geldig = controleHaakje(openingshaakje);
							if (!geldig) return false;
							break;
				case '}': 	openingshaakje = '{';
							geldig = controleHaakje(openingshaakje);
							if (!geldig) return false;
							break;
				case ')': 	openingshaakje = '(';
							geldig = controleHaakje(openingshaakje);
							if (!geldig) return false;
							break;
				case '[':
				case '{':
				case '(': Character character = new Character( kar );
				          stack.push(character); break;
			}
		}//end-for
		if (stack.isEmpty())
			return true;
		else
			return false;
   }

   private static boolean controleHaakje( char hetHaakje )
   {
        try
        {
		   //Haakje van de stack afhalen
		   Object haakje = stack.pop();
		   //Conversie
           Character openingshaakje = (Character) haakje;
           //controle: komt het haakje overeen met het openingshaakje
		   if (openingshaakje.charValue() == hetHaakje)
		         return true;
		   else
		         return false;
		}
		// catch exception if stack is empty when item popped
		catch ( EmptyListException emptyListException )
		{
		    return false;
        }
   }


} // end class StackComposition

