//Hfd. 20 OEF 2

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ControleHaakjesTest extends JFrame
{
   private JTextField expressieField, resultaatField;

   // set up GUI
   public ControleHaakjesTest()
   {
      super( "Expressie" );

      Container container = getContentPane();
      container.setLayout( new FlowLayout() );

      container.add( new JLabel( "Geef een expressie " ) );

      // textfield om de expressie in te kunnen geven
      expressieField = new JTextField( 20 );
      container.add( expressieField );

      expressieField.addActionListener(

         new ActionListener() { // anonymous inner class

            // controleert de expressie en geeft het resultaat weer
            public void actionPerformed( ActionEvent event )
            {
               String tekst = controleInput(expressieField.getText());
               resultaatField.setText( tekst );
            }

         } // end anonymous inner class

      ); // end call to addActionListener

      // textfield om het resultaat weer te kunnen geven
      resultaatField = new JTextField( 33 );
      resultaatField.setEditable( false );
      container.add( resultaatField );

      // button om de expressie te kunnen controleren
      JButton controleButton = new JButton( "controle" );
      container.add( controleButton );

      controleButton.addActionListener(

         new ActionListener() { // anonymous inner class

            // controleert de expressie en geeft het resultaat weer
            public void actionPerformed( ActionEvent event )
		    {
		     	String tekst = controleInput(expressieField.getText());
		    	resultaatField.setText( tekst );
            }

         } // end anonymous inner class

      ); // end call to addActionListener

      setSize( 400, 120 );
      setVisible( true );

   } // end constructor

   //De expressie controleren
   private String controleInput(String expressie)
   {
       if (expressie.length() != 0)
		{
		   boolean geldig = ControleHaakjes.controle( expressieField.getText() );
		   if (geldig)
			  return "geldige expressie";
		   else
			 return "geen geldige expressie";
		}
		else
		 return "een expressie ingeven a.u.b.";
   }// einde methode controleInput

   public static void main( String args[] )
   {
      ControleHaakjesTest application = new ControleHaakjesTest();
      application.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
   }

} // end class ControleHaakjesTest

