//Hfd. 20 OEF 1

// class List definition
public class GesorteerdeLijst extends List
{

   // construct empty List with "list" as the name
   public GesorteerdeLijst()
   {
      super( "gesorteerdeLijst" );
   }

   // insert Object at List
   public synchronized void toevoegen( String naam )
   {
      if ( isEmpty() )
         //De gelinkte lijst is leeg
         insertAtFront(naam);
      else
      {
       ListNode currentNode = getFirstNode();
       ListNode previousNode = null;
       while (currentNode != null && naam.compareTo(currentNode.getData()) > 0)
       {
		   previousNode = currentNode;
		   currentNode = currentNode.getNext();
	   }
       if (currentNode == getFirstNode())
       		//VOORAAN TOEVOEGEN
       		insertAtFront(naam);
       else if (currentNode == null)
        	//ACHTERAAN TOEVOEGEN
        	insertAtBack(naam);
        else
       {//MIDDEN TOEVOEGEN
       ListNode nieuweNode = new ListNode( naam, null );
       previousNode.setNext(nieuweNode);
       nieuweNode.setNext(currentNode);
       }
	  }
   }

   // remove Object at List
   public synchronized String verwijderen( String naam )
   {
      if ( isEmpty() ) // throw exception if List is empty
         throw new EmptyListException( naam );

       ListNode currentNode = getFirstNode();
       ListNode previousNode = null;
       int cijfer=0;
       String naamGewist;
       //naam zoeken in de lijst
       while (currentNode != null)
       {
		   cijfer = naam.compareTo(currentNode.getData());
		   if (cijfer > 0)
		   { //verder zoeken
		   		previousNode = currentNode;
		   		currentNode = currentNode.getNext();
	   	   }
	   	   else
	   	   		break;
	   }

	   if (cijfer != 0)
	        //de naam komt niet voor
			return "de naam komt niet voor";

       if (currentNode == getFirstNode())
       		//VOORAAN VERWIJDEREN
       		naamGewist = (String) removeFromFront();
       else if (currentNode == getLastNode())
        	//ACHTERAAN VERWIJDEREN
        	naamGewist = (String) removeFromBack();
        else
       {
		   //MIDDEN VERWIJDEREN
       		naamGewist = (String) currentNode.getData();
       		previousNode.setNext(currentNode.getNext());
		}
       return naamGewist;
   }

} // end class GesorteerdeLijst
