
public class ExpressieBoom
{

  private Tree tree;

   public ExpressieBoom()
   {
      tree = new Tree();
   }

   // een expressie in de binaire boom plaatsen
   public synchronized void toevoegenExpressie( String expressie )
   {
      char kar = expressie.charAt(0);
      tree.setRoot(new TreeNode(kar));

      for (int i = 1; i < expressie.length(); i++)
      {
      	kar = expressie.charAt(i);
      	if (kar == '+' ||
      		kar == '-' ||
      		kar == '*' ||
      		kar == '/')
      	{
			TreeNode previousRoot = tree.getRoot();
			tree.setRoot(new TreeNode(kar));
			tree.getRoot().setLeftNode(previousRoot);
		}
      	else
      		tree.getRoot().insert(kar);
	  }
   }


   // begin inorder traversal
   public synchronized void inorderTraversal()
   {
      tree.inorderTraversal();
   }

} // end class Tree
