public class TreeNode
{

   private TreeNode leftNode;
//char i.p.v. int
   private char data;
   private TreeNode rightNode;

   // initialize data and make this a leaf node
   public TreeNode( char nodeData )
   {
      data = nodeData;
      leftNode = rightNode = null;  // node has no children
   }

//Methoden toegevoegd:
	public void setLeftNode(TreeNode leftNode)
	{
		this.leftNode = leftNode;
	}

	public void setRightNode(TreeNode leftNode)
	{
		this.rightNode = rightNode;
	}

	public void setData(char data)
	{
		this.data = data;
	}

	public char getData()
	{
		return data;
	}

	public TreeNode getLeftNode()
	{
		return leftNode;
	}

	public TreeNode getRightNode()
	{
		return rightNode;
	}

// methode insert aangepast
   public synchronized void insert( char insertValue )
   {
      TreeNode node = new TreeNode( insertValue );
      rightNode = new TreeNode(insertValue);
   } // end method insert

} // end class TreeNode

